<?php

namespace Modules\Cotacao\Modules\ListaPreco\Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;

class Sup01300VerificacaoListaPrecoController extends \Zeedhi\Framework\Controller\Report
{

    protected $entityManager;
    protected $birtStrategy;
    protected $newCode;
    protected $environment;
    protected $connection;
    protected $dataSourceManager;
    protected $service;

    public function __construct($reportService, $entityManager, $birtStrategy, $newCode, $environment, $connection, $dataSourceManager, $Sup01300VerificacaoListaPrecoService)
    {

        $this->entityManager     = $entityManager;
        $this->birtStrategy      = $birtStrategy;
        $this->reportService     = $reportService;
        $this->newCode           = $newCode;
        $this->environment       = $environment;
        $this->connection        = $connection;
        $this->dataSourceManager = $dataSourceManager;
        $this->service           = $Sup01300VerificacaoListaPrecoService;
    }

    public function updateItemcole(DTO\Request\Row $request, DTO\Response $response)
    {
        try {
            $row = $request->getRow();
            $row['CDFILIAL'] = $this->service->getCentralCompras($this->environment->getCdFilial());
            $this->service->updateItemcole($row);
        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), 1));
        }
    }

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response)
    {
        $row = $request->getRow();

        //try {

        $row['CDFILIAL'] = $this->service->getCentralCompras($this->environment->getCdFilial());
        $row['NRORG'] = $this->environment->getNrOrg();

        if ($row['CDOPERADOR'] != 'T') {
            $nrlistaForn = $this->criarListaValores($row['CDOPERADOR']);
            $row['CDOPERADOR'] = "_NRLISTA=" . $nrlistaForn;
        }

        if ($row['CDREGIAO'] != 'T') {
            $nrlistaForn = $this->criarListaValores($row['CDREGIAO']);
            $row['CDREGIAO'] = "_NRLISTA=" . $nrlistaForn;
        }

        $row['CDOPERADOR1'] = $row['CDOPERADOR'];
        $row['CDOPERADOR2'] = $row['CDOPERADOR'];
        $row['CDOPERADOR3'] = $row['CDOPERADOR'];
        $row['CDREGIAO1']   = $row['CDREGIAO'];

        $this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));
        $this->stNomeRel = $this->getReportName($row);
        $this->reportMapping[$this->stNomeRel] = array(
            'strategy' => $row['STRATEGY'],
            'parameterMapping' => array(
                "CDREGIAO"    => "L_CDREGIAO1",
                "CDREGIAO1"   => "L_CDREGIAO2",
                "CDPRODINI"   => "P_CDINI",
                "CDPRODFIN"   => "P_CDFIN",
                "CDFILIAL"    => "P_CDFILIAL",
                "CDOPERADOR"  => "L_CDOPERADOR1",
                "CDOPERADOR1" => "L_CDOPERADOR2",
                "CDOPERADOR2" => "L_CDOPERADOR3",
                "CDOPERADOR3" => "L_CDOPERADOR4",
                "NRORG"       => "NRORG"
            )
        );
        //} catch (\Exception $e) {
        //    $response->setError(new DTO\Response\Error($e->getMessage(), 1));
        //}
    }

    protected function criarListaValores($lista)
    {
        try {
            $nrlista = $this->newCode->getCodeByTableName('LISTA', $this->environment->getNrOrg());
            $valores = explode('_', $lista);
            foreach ($valores as $key) {
                $this->service->insertLista($nrlista, $key);
            }
            return $nrlista;
        } catch (\Exception $e) {
            throw $e;
        }
    }
}
