<?php

namespace Modules\Fornecimento\Modules\AutorizacaoFornecimento\Controllers;

use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DTO\Request\DataSet;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Error;

class AcompanhamentoAprovacaoController
{
    protected $service;

    public function __construct($service)
    {
        $this->service = $service;
    }

    public function salvaAnexoGrid(Row $row, Response $response)
    {
        try {
            $row  = $row->getRow();

            $this->service->salvaAnexoGrid($row);
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
    }

    public function deleteAnexoGrid(DataSet $dataset, Response $response)
    {
        try {
            $rows = $dataset->getDataSet()->getRows();

            $this->service->deleteAnexoGrid($rows);
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
    }
}
